package model.elements;

import model.World;
import model.miscellaneous.RND;
import model.types.Point;

import java.util.*;

public class Ant {

    private Point nest;
    private Point previousPosition;
    private Point currentPosition;
    private Set<Point> history;

    public Ant(int x, int y) {
        currentPosition = previousPosition = nest = new Point(x, y);
        history = new HashSet<>();
    }

    public Point getCurrentPosition() {
        return currentPosition;
    }

    public Point getPreviousPosition(){
        return previousPosition;
    }


    public Set<Point> getHistory(){
        return history;
    }

    public void goHome(){
        currentPosition = previousPosition = nest;
        history = new HashSet<>();
    }


    public void move(Point p){
        if(p == null) goHome();
        else {
            history.add(currentPosition);
            previousPosition = currentPosition;
            currentPosition = p;
        }
    }

    public double manhattanDistance(Point p) {
        double dx = currentPosition.getX()-p.getX();
        double dy = currentPosition.getY()-p.getY();
        return Math.sqrt(dx*dx+dy*dy);
    }
}
