package view;

import model.World;
import model.elements.Ant;
import model.elements.Cell;
import model.types.CellType;

/**
 * Created by filip on 14.04.16..
 */
public class AsciiView implements IView{

    private World world;

    public AsciiView(World world){
        this.world = world;
    }

    public void produce(){

        int height = world.getHeight();
        int width  = world.getWidth();

        char [][] worldRepresentation = new char[height][width];

        StringBuilder sb = new StringBuilder();

        //display domain
        for(int j = 0; j<height; ++j){
            for(int i = 0; i<width; ++i){
                Cell element = world.getElement(i,j);
                if(element.getType() == CellType.WALL){
                    worldRepresentation[j][i] ='#';
                } else {
                    worldRepresentation[j][i] =' ';
                }
/*
                if(element.isFree()){
                    if(element.getFoodLevel()>9) worldRepresentation[j][i] = '*';
                    else if(element.getFoodLevel()>0) worldRepresentation[j][i] = (char) ('0' + element.getFoodLevel());
                    else worldRepresentation[j][i] = ' ';
                } else if (element.isNest()){
                    worldRepresentation [j][i] = '$';
                } else {
                    worldRepresentation [j][i] = '#';
                } */
            }
        }

        //display agents
        for(Ant ant : world.getPopulation()){
            worldRepresentation[ant.getCurrentPosition().getY()][ant.getCurrentPosition().getX()] = '+';
        }

        for(int i = 0; i<worldRepresentation.length; ++i){
            sb.append(worldRepresentation[i]);
            sb.append("\n");
        }

        System.out.println(sb.toString());

    }

}
