package view;

import model.World;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ContainerAdapter;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.function.Consumer;

/**
 * Created by filip on 19.05.16..
 */
public class IntegerInputComponent extends JComponent {

    private JLabel      label;
    private JTextField  field;
    private Consumer<Integer> changeValue;

    public IntegerInputComponent(String defaultDescription, Integer value, Consumer<Integer> changeValue){
        this.changeValue = changeValue;
        setLayout(new GridLayout(2,1));
        label = new JLabel(defaultDescription);
        field = new JTextField(String.valueOf(value));
        label.setPreferredSize(new Dimension(200, 30));
        field.setPreferredSize(new Dimension(200, 30));
        //setBorder(BorderFactory.);
        setOpaque(true);
        add(label);
        add(field);
        /*field.addPropertyChangeListener((evt) -> {
                String oldValue = (String)evt.getOldValue();
                String newValue = (String)evt.getNewValue();
                try{
                    Integer newInteger = Integer.parseInt(newValue);
                    changeValue.accept(newInteger);
                } catch (NumberFormatException e){
                    field.setText(oldValue);
                }
        });*/
        setVisible(true);
    }

    public String getValue(){
        return field.getText();
    }

    public void setValue(Integer i){
        this.field.setText(String.valueOf(i));
    }
}
